#!/bin/csh

./strip.pl -stop=stopwords.txt charter_e.html  > charter_e.lst
./strip.pl -stop=stopfrench.txt charter_f.html  > charter_f.lst

# Make short samples: from beginning thru para 4, 19, 29
head -40 charter_e.lst > short0_e.lst
head -41 charter_f.lst > short0_f.lst
head -131 charter_e.lst > short1_e.lst
head -139 charter_f.lst > short1_f.lst
head -212 charter_e.lst > short2_e.lst
head -223 charter_f.lst > short2_f.lst


# Produce Absurdist input files without external similarity
java -Dstem=en Mkcs short0_e.lst > short0_e.cst
java -Dstem=fr Mkcs short0_f.lst > short0_f.cst
java -Dstem=en Mkcs short1_e.lst > short1_e.cst
java -Dstem=fr Mkcs short1_f.lst > short1_f.cst
java -Dstem=en Mkcs short2_e.lst > short2_e.cst
java -Dstem=fr Mkcs short2_f.lst > short2_f.cst
java -Dstem=en Mkcs charter_e.lst > charter_e.cst
java -Dstem=fr Mkcs charter_f.lst > charter_f.cst

# Produce Absurdist input files with external similarity
java -Dstem=en -Dfv=true Mkcs short0_e.lst > short0_e.ext.cst
java -Dstem=fr -Dfv=true Mkcs short0_f.lst > short0_f.ext.cst
java -Dstem=en -Dfv=true Mkcs short1_e.lst > short1_e.ext.cst
java -Dstem=fr -Dfv=true Mkcs short1_f.lst > short1_f.ext.cst
java -Dstem=en -Dfv=true Mkcs short2_e.lst > short2_e.ext.cst
java -Dstem=fr -Dfv=true Mkcs short2_f.lst > short2_f.ext.cst
java -Dstem=en -Dfv=true Mkcs charter_e.lst > charter_e.ext.cst
java -Dstem=fr -Dfv=true Mkcs charter_f.lst > charter_f.ext.cst

grep relations *.ext.cst

# Internal evidence only
java -Xmx80m -classpath  ../classes  -DalphaShare=0 -DcompactCache=true driver.CmpDriver   short2_e.cst short2_f.cst  > short2.i.out 

java -Xmx80m -classpath  ../classes  -DalphaShare=0 -DcompactCache=true -DL=0.1 driver.CmpDriver   short2_e.cst short2_f.cst  > short2.i.L0_1.out 

# External and internal
java -Xmx80m -classpath ../classes   -DalphaShare=0.5 -DcompactCache=true driver.CmpDriver   short2_e.ext.cst short2_f.ext.cst  > short2.ei.out 

java -Xmx80m -classpath ../classes   -DalphaShare=0.5 -DcompactCache=true -DL=0.1 driver.CmpDriver   short2_e.ext.cst short2_f.ext.cst  > short2.ei.L0_1.out 

# External only
java -Xmx80m -classpath  ../classes -DalphaShare=1.0 -DcompactCache=true  driver.CmpDriver  short2_e.ext.cst short2_f.ext.cst  > short2.e.out 

