///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng, Vladimir Menkov
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


package absurdist;


/** Node pair (i,j). This is an auxiliary class used to store information
    about link similarity in Absurdist. 
*/
public class Link {
    public int i, j;
    public Link(int i, int j) {
	this.i=i; 
	this.j=j;
    }

   /** Just something... I am afraid the standard hashCode() does
	not work right */
    public int hashCode() {
	int c = (i << 16) + j;
	return c;
    }

    /** (Looks like you got to have your own equals() if you use this class
	as a Hashtable key.)  */
    public boolean equals(Object _z) {
	if (_z instanceof Link) {
	    Link z = (Link)_z;
	    return i==z.i && j==z.j;
	} else {
	    return false;
	}
	    
    }

    public String toString() {
	return "("+i+"-"+j+")";
    }
    /** Special value; used to form keys for storing "similarity with 
	an empty link". */
    static final Link EMPTY = new Link(-1,-1);

};
