///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng, Vladimir Menkov
// Computer Science, Indiana University
// Feb-Oct 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


package absurdist;
  
import java.util.*;

/** LinkSimCache implemented as a Hashtable
    @see LinkSimCache 
*/

class  LinkSimCacheHash extends Hashtable implements  LinkSimCache {
    /** Stores the value representing Sim(lo,ln). Returns
	the value previously stored in the table (NaN if
	none was stored)
    */
    public double put( Link lo,  Link ln, double val) {
	Double d = (Double)super.put( new LinkPair( lo, ln), new Double(val));
	return (d==null)? Double.NaN : d.doubleValue();
    }

    /** Retrieves the value representing Sim(lo,ln), or
	NaN if	none was stored)
    */
    public double get( Link lo,  Link ln) {
	Double d = (Double)super.get( new LinkPair( lo, ln));
	return (d==null)? Double.NaN : d.doubleValue();
   }

    /** No effect */
    public void setSizes(int loCnt, int lnCnt){}


}
