///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


package driver;

import java.io.*;

import absurdist.*;


/** Class SimpleDriver
    The main class to run ABSURDIST II with a simple command-line interface.
    Compares two system read in from text files.
*/
public class SimpleDriver
{
    static boolean debugMode = false;

    public static void debug( String s )
    {
        if ( debugMode )
            System.out.print( s );
    }
        
    public static void debugln( String s )
    {
        if ( debugMode )
            System.out.println( s );
    }
        
    public static void error( String s )
    {
        //// if ( errorMode )
        System.err.println( s );
    }
        
    public static void main( String[] args )
    {
	/* fix this part for random graphs.

        if ( args.length < 3 ) {
            error( "Please input number of concepts, edge fullness, and noise" );
            return;
        }
        
        try {
            String name = args[0];
            int n = Integer.parseInt( args[1] );
            double fullness = Double.parseDouble( args[2] );
            double noise = Double.parseDouble( args[3] );
            ConceptSystem systemO = new ConceptSystem( n, fullness );
            ConceptSystem systemN = new ConceptSystem( systemO, 0, 0, noise, 0 );
            Absurdist absurdist = new Absurdist( systemO, systemN );
	    boolean expMode = true;
            absurdist.mapSystem( expMode );
            absurdist.print( true );
	}
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
	
	*/

        if ( args.length < 3 || !args[0].equals( "-f" )) {
            error( "Please use -f option with the names of the source and the target system." );
            return;
        }
        
        try {
            ConceptSystem systemO = ConceptSystem.readTxt( args[1] );
            ConceptSystem systemN = ConceptSystem.readTxt( args[2] );
            Absurdist absurdist = new Absurdist( systemO, systemN );
            absurdist.turnOffHistory();
            absurdist.mapSystem();
            absurdist.print();
	    String pName = ( new File( args[1] ) ).getParent();
	    String corFname = pName + "/" + systemO.name + systemN.name + ".cor";
	    String mapFname = pName + "/" + systemO.name + systemN.name + ".map";
	    absurdist.writeCorrespond( corFname );
	    absurdist.writeMap( mapFname );
            /*
            absurdist.printSystem();
            absurdist.printCorrespond();
            absurdist.printMapping();
            */
        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
