package gui;

//import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;


/** An auxiliary dialog window, convenient to pop up a debug window
and wait for  the user to respond.  */
public class Alert extends JFrame {

    volatile boolean done=false;

    /** Blocking methiod: Pops up a message window, and hangs there
	until the "continue" button is pressed. */
    public static void alert(String msg) {

	Alert w = new Alert(msg);
	/** Block until the window is closed */
	for( int cnt=0; !w.done && cnt < 100; cnt++) { 
	    try {Thread.sleep(100); }
	    catch(InterruptedException e) {}
	}
	// looks like we've timed out. let's close the alert window now
	if (!w.done) {
	    w.closeAlert();
	}
    }

    private void closeAlert() {
	setVisible(false);
	dispose();
	done =true;
    }

    private Alert(String msg) {
	super("Absurdist Error Message");
	
	final TextArea ta1 = 
	    new TextArea(msg, 10,70, TextArea.SCROLLBARS_BOTH);
	getContentPane().add(ta1, BorderLayout.CENTER);
	
	Button b = new Button("Continue"); 
	b.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e1) {
		    ta1.setText( ta1.getText() + "\nclick! ");
		    closeAlert();
		}
	    });			
	getContentPane().add(b, BorderLayout.SOUTH);

	pack();
	setVisible(true);
	toFront();
    }

    static public void main(String argv[]) {
	System.out.println("start...");
	alert("This is a test");
	System.out.println("done");
    }

}
