///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST++
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import absurdist.*;
import driver.*;



/** 
    Class GraphPanel:
    The panel on which the concept system graphs are painted.
*/

public class GraphPanel extends JPanel
{
    final static int W = 4;	// maximum link width
    final static float[] dash = { 10, 5 };

    Absurdist absurdist; // corresponding Absurdist reference


    public GraphPanel()
    {
    }
    
    public GraphPanel( Absurdist absurdist )
    {
        this.absurdist = absurdist;
    }
            
    /*
    public void setAbsurdist( Absurdist absurdist )
    {
        this.absurdist = absurdist;
    }    
    */


    /** Paints the correspondence link at a certain step between concept node pair (io, in) in two systems.
     */
    public void paintCorrespond( Graphics2D g, int io, int in, int step )
    {
	ConceptGraph graphO = ( ConceptGraph )absurdist.systemO;
	ConceptGraph graphN = ( ConceptGraph )absurdist.systemN;
	ConceptNode nodeO = graphO.getNode(io);
	ConceptNode nodeN = graphN.getNode(in);
	double correspond = absurdist.correspond[step][io][in];
	ConceptNode ns = graphO.getNode(io);
 	ConceptNode ne = graphN.getNode(in);
        //// Point ps = nodeO.getCenter();
        //// Point pe = nodeN.getCenter();

	if ( absurdist.isMapped() && absurdist.mapON[io] == in ) 
	    g.setStroke( new BasicStroke( W, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 10, dash, 0 ) );
	else 
	    g.setStroke( new BasicStroke( 1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 10, dash, 0 ) );
	////float c = (float)( 1 - correspond );
	g.setColor( new Color( 0f, 0f, 0f, (float)correspond ) );
	g.drawLine( ns.x, ns.y, ne.x, ne.y );
	//// int width = ( int )( correspond * W );	
        //// g.setStroke( new BasicStroke( width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 10, dash, 0 ) );
	//// g.drawLine( ps.getX(), ps.getY(), pe.getX(), pe.getY() );
    }

    /** Paints the component.
     */
    public void paintComponent( Graphics g )
    {	
	Graphics2D g2D = ( Graphics2D )g;
	super.paintComponent( g2D );
	
	//// AppletDriver.debugln( "GraphPanel paint: ( " + getWidth() + ", " + getHeight() + " )" );	
        //// g2D.setColor( Color.black );
        //// g2D.fillRect( 0, 0, getWidth(), getHeight() );

	ConceptGraph graphO = ( ConceptGraph )absurdist.systemO;
	ConceptGraph graphN = ( ConceptGraph )absurdist.systemN;
	if ( graphO != null ) 
	    graphO.paint( g2D );	
	if ( graphN != null )
	    graphN.paint( g2D );	

	// paint the correspondence links if it's being or already mapped
	/*
	  if ( absurdist != null )
	    Test.debugln(" GraphPanel.paint: in status " + absurdist.status );
	*/
	if ( !absurdist.isUnmapped() && absurdist.nStep > 0 ) {
	    int no = graphO.getConceptNum();
	    int nn = graphN.getConceptNum();
	    for ( int io=0; io<no; io++ )
		for ( int in=0; in<nn; in++ ) 
		    paintCorrespond( g2D, io, in, absurdist.nStep-1 );	 	   
	}
    }        
}
