package penalty;

import absurdist.ConceptSystem;

/** A common interface for an algorithm for matching two concept
systems. This interface is implemented by Absurdist and
PenaltyMinimizer
*/
public interface SystemMatcher {

    /** Finds a correspondence between two concept systems. 
	@param systemO 	The first concept system to match. In our experiments,
	this is the "original" one.
	@param systemN The second system to match. In our experiments,
	this system has been obtained from the first one by
	adding some "noise".
    */
    public void mapSystem( ConceptSystem systemO, ConceptSystem systemN )
    throws Exception;
    /** Prints the two systems being matched (the original and noisy
     concept systems, the correspondence matrix, and the final
     mappings. */
    public void print(boolean toFile) throws Exception;
 
}
