///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST++
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
// Class Test5
//   The class to run Test 5 for ABSURDIST.
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;


public class Test5 extends TestBase
{
    
    int nLabel;
    int directMode;
    boolean weighted;
    
  /** Creates the base system. Derived classes may redefine
	this method according to how they need to create it.
    */
      
    ConceptSystem getSysO() throws Exception {
	return  new ConceptSystem( n, 1, false, false, 
				   fullness, nLabel, directMode, weighted );
    }

    /** Creates the noisy system. Derived classes may redefine
	this method according to how they need to create it.
    */
    ConceptSystem getSysN( ConceptSystem systemO)  throws Exception{
	return   new ConceptSystem( systemO, 0, 0, noise, noise ); 
    }

   
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "Please input number of concepts and noise" );
            return;
        }
        
	Test5 test=new Test5();
	test.mainCall( args );
    }

    void mainCall(String[] args ) {
        try {
            int n = 12;
            double fullness = 0.5;
	    nLabel = Integer.parseInt( args[0] );
	    directMode = Integer.parseInt( args[1] );
	    weighted = args[2].equals( "w" ) ? true : false;
            double noise = Double.parseDouble( args[3] ) / 100;

	    String ls = "l" + nLabel;
	    String ds = "d" + directMode;
	    String ws = weighted ? "weighted" : "unweighted";
	    String str = ls + ds + args[2];

	
	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test5/" +  str + "n" + args[3] + ".t5";
	    PrintStream out = new PrintStream(new FileOutputStream( fname));

	    //PrintStream out = new PrintStream( new FileOutputStream( str + "n" + args[3] + ".tt4" ) );
	    out.println( "Test 5: nLabel = " + nLabel + 
			 ", directed = " + directMode + ", " + ws + 
			 ", noise = " + (noise*100) + "%, " );

	    //NRuns = 200;
	    mainLoop( n, fullness, noise, NRuns, out);

	}
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
