///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;


/** Class TestLoopDensity
    runs Test 2b for iteration times vs graph density (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      L = 0.01
      Concept number = 12
      Noise level = 2%
    Varying:         
      Relation fullness = 10%, 20%, 30%, 40%, 50%           
      maxLoop = 200, 500, 1000, 2000, 3000
*/                
public class TestLoopDensity extends TestBase
{
       
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "Usage: java TestLoopDensity fullness_pct max_iteration_cnt" );
            return;
        }
        
        try {
            int n = 12;
            double fullness = Double.parseDouble( args[0] ) / 100;
	    Absurdist.maxLoop = Integer.parseInt( args[1] );
	    double noise = 0.02;

	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test2b/f" + args[0] + "l" + args[1] + ".t2b";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );
	    out.println( "Test 2b: relation fullness = " + args[0] + "%, maxLoop = " + Absurdist.maxLoop );

	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);

        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
