///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;


/** Class TestLoopSize
    runs Test 2a for iteration times vs graph size (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      L = 0.01
      Relation fullness = 50%           
      Noise level = 2%
    Varying:
      Concept number = 8, 10, 12, 15, 20
      maxLoop = 200, 500, 1000, 2000, 3000
*/                
public class TestLoopSize extends TestBase
{
 
        
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "Please input number of concepts and iterations" );
            return;
        }
        
        try {
            int n = Integer.parseInt( args[0] );
	    double fullness = 0.5;
	    Absurdist.maxLoop = Integer.parseInt( args[1] );
	    double noise = 0.02;

	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test2a/n" + args[0] + "l" + args[1] + ".t2a";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );
	    out.println( "Test 2a: concepts # = " + n + ", maxLoop = " + Absurdist.maxLoop );
	    out.println( "\nindex\tmisCon\tmisRel\taccuracy" );
	    out.println( "----------------------------------------" );

	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);

        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
