///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;


/** Class TestNoiseDensity
    runs Test 1d on noise tolerance vs average graph degree (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      maxLoop = 3000, L = 0.01
      Concept number = 20
    Varying:
      Relation degree = 2, 4, 6, 8, 10
      Noise level = 0, 2%, 4%, 6%, 8%
*/                
public class TestNoiseDegree extends TestBase
{
  
        
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "Please input relation fullness and noise level" );
            return;
        }
        
        try {
            int n = 20;
	    int degree = Integer.parseInt( args[0] );
            double fullness = ( double )degree / ( n-1 );
            double noise = Double.parseDouble( args[1] ) / 100;

	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test1d/d" + args[0] + "n" + args[1] + ".t1d";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );

	    out.println( "Test 1d: relation degree = " + args[0] + ", noise = " + args[1] + "%" );

	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);

        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
