///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;


/** Class TestNoiseDensity
    runs Test 1b on noise tolerance vs graph density (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      maxLoop = 3000, L = 0.01
      Concept number = 12
    Varying:
      Relation fullness = 10%, 20%, 30%, 40%, 50%           
      Noise level = 0, 2%, 4%, 6%, 8%
*/                
public class TestNoiseDensity  extends TestBase
{
 
    public static void main( String[] args )
    {
       if ( args.length < 2 ) {
            error( "Please input relation fullness and noise level" );
            return;
        }
        
        try {
            int n = 12;
            double fullness = Double.parseDouble( args[0] ) / 100;
            double noise = Double.parseDouble( args[1] ) / 100;

	    try {
		NRuns = Integer.parseInt( args[2] );
	    } catch(Exception e) {}


	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test1b/f" + args[0] + "n" + args[1] + ".t1b";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );
	    out.println( "Test 1b: relation fullness = " + args[0] + "%, noise = " + args[1] + "%" );
	    out.println("# n=" +n+", Damping mode=" + Absurdist.dampingMode);
	
	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);

        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
