///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 
import java.text.*; 

import absurdist.*;

/** Class TestNoiseSize
    runs Test 1a on noise tolerance vs graph size (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      maxLoop = 3000, L = 0.01
      Relation fullness = 50%           
    Varying:
      Concept number = 8, 10, 12, 15, 20
      Noise level = 0, 2%, 4%, 6%, 8%
*/                
public class TestNoiseSize extends TestBase
{
   
        
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "java test.TestNoiseSize number_of_concepts noise_level_pct [n_runs]" );
            return;
        }
        
        try {            
            int n = Integer.parseInt( args[0] );
	    double fullness = 0.5;
            double noise = Double.parseDouble( args[1] ) / 100;
	
	    try {
		NRuns = Integer.parseInt( args[2] );
	    } catch(Exception e) {}

    
	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test1a/n" + args[0] + "n" + args[1] + ".t1a";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );
	    out.println( "Test 1a: concepts # = " + n + ", noise = " + args[1] + "%" );
	    out.println("# Fullness=" +fullness+", Damping mode=" + Absurdist.dampingMode);

	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);

        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
