///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST II
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package test;

import java.io.*; 

import absurdist.*;

/** Class TestNoiseSizeDgr
    runs Test 1c on noise tolerance vs graph size (each parameter setting is tested with 100 runs).
    Fixed: 
      Graph type = simple asymmetric graph (unlabeled, undirected, unweighted)
      maxLoop = 3000, L = 0.01
      Average relation degree = 5           
    Varying:
      Concept number = 8, 10, 12, 15, 20
      Noise level = 0, 2%, 4%, 6%, 8%
*/                
public class TestNoiseSizeDgr extends TestBase
{
  
        
    public static void main( String[] args )
    {
        if ( args.length < 2 ) {
            error( "Please input number of concepts and noise level" );
            return;
        }
        
        try {            
            int n = Integer.parseInt( args[0] );
	    int degree = 5;
	    double fullness = ( double )degree / ( n-1 );
            double noise = Double.parseDouble( args[1] ) / 100;
	    
	    String testDir = Absurdist.prop.getOption("testDir", ".");
	    String fname = testDir + "/test1c/n" + args[0] + "n" + args[1] + ".t1c";
	    PrintStream out = new PrintStream( new FileOutputStream( fname ) );
	    out.println( "Test 1c: concepts # = " + n + ", noise = " + args[1] + "%" );

	    TestBase test = new TestBase();
	    test.mainLoop( n, fullness, noise, NRuns, out);
       
        }
        catch ( Exception e ) {
            e.printStackTrace();
            System.exit(0);
        }
    }
}
