///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ABSURDIST++
// Ying Feng
// Computer Scicence, Indiana University
// Feb-Aug 2003
//
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import absurdist.*;
import driver.*;


/** Class PlotPanel:
  The panel on which the concept system variable plots are painted.
*/
public class PlotPanel extends JPanel
{
    //// Absurdist absurdist = null;
    //// public Image buffer = null;	// buffer to store off screen graphics
    Plot rPlot = null;   // plot for internal similarity
    Plot iPlot = null;   // plot for inhibitor
    Plot nPlot = null;   // plot for network input
    Plot cPlot = null;   // plot for correspondence

    public PlotPanel() 
    {
	super();
	addNotify(); // some say this helps createImage() to work right
    }
     
    public PlotPanel( Absurdist absurdist )
    {
	this();
        //// this.absurdist = absurdist;
        setPlot( absurdist );
    }

    /*
    public void PlotPanel( Absurdist absurdist )
    {
        rPlot = new Plot( absurdist.inSim, absurdist.nStep, 0, 0, getWidth(), getHeight()/4 );
        iPlot = new Plot( absurdist.inhib, absurdist.nStep, 0, getHeight()/4, getWidth(), getHeight()/4 );
        nPlot = new Plot( absurdist.netIn, absurdist.nStep, 0, getHeight()/2, getWidth(), getHeight()/4 );
        cPlot = new Plot( absurdist.correspond, absurdist.nStep, 0, getHeight()*3/4, getWidth(), getHeight()/4 );  
    }
    */

    /** This must not be done in the constructor. Instead, we'll call
	this method the first time when buffer is needed. See
	http://java.sun.com/people/linden/faq_c.html#AWT */

    /*
    void createBuffer() { 
        buffer = createImage( getWidth(), getHeight() );        
	//// if (buffer == null) throw new Exception("Cannot create buffer");
    }
    */
    
    public void setAbsurdist( Absurdist absurdist )
    {
        //// this.absurdist = absurdist;
        //// buffer = createImage( getWidth(), getHeight() );   // already done in constructor?
        setPlot( absurdist );
    }
     
    // Set parameters for all the plots.
    public void setPlot( Absurdist absurdist )
    {
        rPlot = new Plot( absurdist.inSim, absurdist.nStep, 0, 0, getWidth(), getHeight()/4 );
        iPlot = new Plot( absurdist.inhib, absurdist.nStep, 0, getHeight()/4, getWidth(), getHeight()/4 );
        nPlot = new Plot( absurdist.netIn, absurdist.nStep, 0, getHeight()/2, getWidth(), getHeight()/4 );
        cPlot = new Plot( absurdist.correspond, absurdist.nStep, 0, getHeight()*3/4, getWidth(), getHeight()/4 );
    }

    /** Sets the current plot step for all the plots. */
    public void setPlotSteps( int nStep )
    {
        rPlot.setSteps( nStep );
        iPlot.setSteps( nStep );
        nPlot.setSteps( nStep );
        cPlot.setSteps( nStep );
    }

    /** Paints the component. */
    public void paintComponent( Graphics g )
    {	
        Graphics2D g2D = ( Graphics2D )g;
	super.paintComponent( g2D );
	
	//// Test.debugln( "PlotPanel paint: ( " + getWidth() + ", " + getHeight() + " )" );
        //// g2D.setColor( Color.white );
        //// g2D.fillRect( 0, 0, getWidth(), getHeight() );

	// paint the line plots for R, I, N, and C
	if ( rPlot != null )
	    rPlot.paint( g2D );	
	if ( rPlot != null )
	    iPlot.paint( g2D );	
	if ( nPlot != null )
	    nPlot.paint( g2D );	
	if ( cPlot != null ) {
	    cPlot.paint( g2D );	
	}
    }        
}


